<template>
  <div id="register">
    <input type="text" v-model="username" placeholder="username" />
    <input type="password" v-model="password" placeholder="password" />
    <input type="password" v-model="password_confirm" placeholder="confirm password" />
    <input type="email" v-model="email" placeholder="email" />
    <input type="text" v-model="first_name" placeholder="first name" />
    <input type="text" v-model="last_name" placeholder="last name" />

    <select
      name="specialization"
      id="specialization"
      v-model="specialization_id"
      @change="specChanged"
    >
      <option value="null" disabled>Please select an option</option>
      <option v-for="spec in specialization_list" :key="spec.id" :value="spec.id">{{spec.name}}</option>
    </select>

    <button @click="ExtendedUserRegister">Register</button>

    <span id="error_message">{{error_message}}</span>
  </div>
</template>

<script>
import axios from "axios";
import { getSpecializations } from "../utils/apiUtils";
const spec_url = "http://127.0.0.1:8000/users/specialization/";
const extended_user_url = "http://127.0.0.1:8000/users/extended_users/";

export default {
  name: "Register",
  data: function() {
    return {
      username: "",
      password: "",
      password_confirm: "",
      email: "",
      first_name: "",
      last_name: "",
      specialization_id: null,
      specialization_list: [],
      error_message: ""
    };
  },
  methods: {
    ExtendedUserRegister() {
      if (this.password !== this.password_confirm) {
        this.error_message = "fields with passwords don't match";
        return;
      }

      axios.post(extended_user_url, {
        user: {
          username: this.username,
          password: this.password,
          email: this.email,
          first_name: this.first_name,
          last_name: this.last_name,
        },
        specialization: this.specialization_id,
      })
      .then(response => {
        console.log("res from: ",extended_user_url, response);
        if (response.statusText === "Created") {
          window.alert("user created");
        }
      })
      .catch(error => {
        console.log("registration extended user error", error);
        if (error.response) {
          console.log("registration error: ", error.response);
          let message = "";
          // @TODO refactor this!!
          if (error.response.data['user']) {
            for (let [key, value] of Object.entries(error.response.data['user'])) {
              message += `${key}: ${value.join()} \n`;
            }
          }
          if (error.response.data['specialization']) {
            let value = error.response.data['specialization'];
            message += `${'specialization'}: ${value.join()} \n`;
          }
          this.error_message = message;
        }
      });
    },
    specChanged() {},
  },
  mounted: function() {
    (async () => {
        this.specialization_list = await getSpecializations();
    })();
  }
};
</script>

<style scoped>
#register {
  font-family: Avenir, Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
  margin-left: 40%;
  margin-right: 40%;
}
input {
  width: 100%;
  padding: 12px 20px;
  margin: 8px 0;
  border: 1px solid #ccc;
  border-radius: 4px;
  box-sizing: border-box;
  text-align: center;
}

select {
  width: 100%;
  padding: 12px 20px;
  margin: 8px 0;
  border: 1px solid #ccc;
  border-radius: 4px;
  box-sizing: border-box;
  text-align: center;
}
#error_message {
  color: red;
}
</style>>